// Task 1

const gatherNums = (nums) => {
    const totalSum = nums.reduce((acc, cur) => acc + cur);

    console.log(`Total: ${totalSum}`);
};

// console.log(gatherNums([2,3,4]));

// Task 2

const calculateTotalTax = (profit) => {
    const fixedTax = 0.20;

    const monthlyIncome = parseFloat(profit.reduce((acc, cur) => acc + cur, 0));

    const totalIncome = monthlyIncome * (1 + fixedTax); 

    return console.log(`Based on ${fixedTax}% tax, the total income will be: ${totalIncome}`);
};

console.log(calculateTotalTax([900, 100]));

// Task 3

const countWords = ([word, letter]) => {
    let count = 0;

    for (let char of word) {
        if (char === letter) {
            count++;
        }
    }

    console.log(`Total matching letters: ${count}`);
};

countWords(['hello', 'l']);

// Task 4

const calcFigure = ([w, h, W, H]) => {
    const area1 = parseInt(w) * parseInt(h);
    const area2 = parseInt(W) * parseInt(H);

    const currentArea = Math.min(parseInt(w), parseInt(h)) * Math.min(parseInt(W), parseInt(H));

    return area1 + area2 - currentArea;
};

console.log(calcFigure(['2', '4', '5', '3']));

// Task 5

const calculateLeapYear = (year) => {
    return (year % 4 === 0 && year % 100 !== 0 || year % 400 === 0) ? 'Yes' : 'No';
};

// console.log(calculateLeapYear(2020));
console.log(calculateLeapYear(1999));
// console.log(calculateLeapYear(2024));

// Task 6

const printNumbers = (n) => {
    let result = "";

    for (let $i = 1; $i <= n; $i++) {
        result += $i;
    }

    console.log(result);
};

printNumbers(3);
// printNumbers(10);

// Task 7

const distanceBetweenPoints = ([x1, y1, x2, y2]) => {
    let point1 = Math.pow(Number(x1) - Number(x2), 2);
    let point2 = Math.pow(Number(y1) - Number(y2), 2);

    const result =  Math.sqrt(point1 + point2);

    console.log(result);
};

distanceBetweenPoints(["0", "0", "3", "4"]);

// Task 8

const countBox = (bottle, boxSize) => {
    const requiredBoxes = Math.ceil(bottle / boxSize);

    console.log(requiredBoxes);
};

countBox(20, 5);

// Task 9

const calculateTriangle = (a, b, c) => {
    const separator = (a + b + c) / 2;

    const countArea = Math.sqrt(
        separator * (separator - a) *
        (separator - b) *
        (separator - c) 
    );

    console.log(countArea);
}

// Task 11

const checkNumber = (number) => {
    if (isNaN(number)) {
        console.log("Not a Number");
    } 
    else if (number % 2 === 0) {
        console.log('Even Number');
    } 
    else {
        console.log('Odd Number');
    }
}

checkNumber(5);
checkNumber(10);

// Task 12

const isPrimeNumber = (number) => {
    if (isNaN(number)) {
        return false;
    } 
    else if (number === 1) {
        return false;
    }

    for (let i = 2; i <= Math.sqrt(number); i++) {
        if (number % i === 0) {
            return false;
        }
    }
    
    return true;
};

console.log(isPrimeNumber(1));
console.log(isPrimeNumber(10));

// Task 13

const calculateDistance = (object) => {
    const [v1, v2, T] = object.map(Number);

    const v1Ms = (v1 * 1000) / 3600;
    const v2Ms = (v2 * 1000) / 3600;
    const tHours = T / 3600;

    const d1 = v1Ms * tHours;
    const d2 = v2Ms * tHours;

    const distance = Math.abs(d1 - d2);

    console.log(distance.toFixed(2));
};

calculateDistance([4, 10, 3200]);

// Task 14

const generateObj = (properties) => {
    const object = {};

    for (let i = 0; i < properties.length; i += 2) {
        const objKey = properties[i];
        const objValue = properties[i + 1];

        object[objKey] = objValue;
    }

    return object;
};

console.log(generateObj(["name", "Pesho", "age", "23", "gender", "male"]));

// Task 15

const findMaxNumber = (number) => {
    let max = number[0];

    for (let i = 1; i < number.length; i++) {
        if (number[i] > max) {
            max = number[i];
        }
    }

    return max;
};

console.log(findMaxNumber([200, 204, 4]));

// Task 17

const upperCaseWords = (word) => {
    const words = word.split(/\W+/);
    
    return upperCase = words.map((word) => word.toUpperCase());
}

console.log(upperCaseWords('Hi, how are you ?').join(', '));